<?php
/*
	[Read8] booked.php

	Version: 3.1
	Name:章节列表/卷编辑程序
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-7-15 12:46
*/

include_once "./include/init.php";
include_once AROOT.'include/booked.func.php';

//权限判断
if(!haspriv(9) && !haspriv(1) && !haspriv(2)) back('无作品管理权限');
if($vid) {//卷操作
	$sql="select book_id from ".__TAB_VOLUME__." where volume_id='$vid'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$bid=$rows['book_id'];
}
$sql="select book_title,user_name,book_author,type_id,book_state from ".__TAB_BOOK__." where book_id='$bid'";
$result=$db->query($sql);
$rows_book=$db->fetch_row($result);
$db->free_result($result);//释放mysql
if(!haspriv(9) && $Global['F_username']<>$rows_book['user_name'] && $Global['F_username']<>$rows_book['book_author']) back('没有该书章节发布和管理权限');

//上传封面
if($_FILES['bookface']['tmp_name']) {
	$bookface=$_FILES['bookface']['tmp_name'];
	$bookface_name=$_FILES['bookface']['name'];
	$bookface_size=$_FILES['bookface']['size'];
		$cut=strrpos($bookface_name,".");
		$filetype=strtolower(substr($bookface_name,$cut+1));
	$C_errormsg=ereg("^php[0-9A-Za-z_.-]+$",basename($bookface))?'':'<li>图片名错误</li>';
	$C_errormsg.= ($bookface_size>30000) ?'<li>封面大小超限</li>':'';
	$C_errormsg.= ($filetype<>'jpg') ?'<li>图片类型错误，请用.jpg后缀</li>':'';
	if($C_errormsg) back($C_errormsg);
	move_uploaded_file($bookface,"html/".$rows_book['type_id']."/$bid/bookface.jpg");
	jumpage("booked.php?bid=$bid","封面上传成功");
}

//增加卷和章节管理
if($vid || $vname || $action) {
	if($newvname) $sql="update ".__TAB_VOLUME__." set volume_name='$newvname' where volume_id='$vid'";
	elseif($neworderid) $sql="update ".__TAB_VOLUME__." set volume_chapterorderid='$neworderid' where volume_id='$vid'";
	elseif($vname) $sql="insert into ".__TAB_VOLUME__." set book_id='$bid',volume_name='$vname',volume_chapterorderid='$orderid'";
	elseif($action=='del') $sql="delete from ".__TAB_VOLUME__." where volume_id='$vid'";
	else $sql='';
	if($action<>'tiny') {
		$db->query($sql);
		//章节表的卷重新生成
		$sql="select volume_id,volume_chapterorderid from ".__TAB_VOLUME__." where book_id='$bid' order by volume_chapterorderid";
		$result_v=$db->query($sql);
		while($rows_v=$db->fetch_row($result_v)) {
			$sql="update ".__TAB_CHAPTER__." set volume_id='".$rows_v['volume_id']."' where book_id='$bid' and chapter_orderid>'".($rows_v['volume_chapterorderid']-1)."'";
			$db->query($sql);
		}
	}
	//书籍文件重生成
	reindex($bid);
	jumpage("booked.php?bid=$bid","卷操作成功");
}

//显示章节内容

//设定搜索关键词
$seokeyword[]='章节列表程序';
$seokeyword[]=$rows_book['book_title'];
getheader($seokeyword);//输出头部

$tpl = new Template('booked');
$tpl->assign($Global['main_assign']);

$sql="select chapter_id from ".__TAB_CHAPTER__." where book_id='$bid'";
$result_num=$db->query($sql);
$chapternum=$db->num_rows($result_num);
$objPage = new Page;
$objPage->setVar(array("bid"=>$bid));
$objPage->setPage($Global['tiplist'],$chapternum,0);
$pagelink=$objPage->output(1);
$limit=$objPage->limit();

$sql="select chapter_id,chapter_title,chapter_orderid,chapter_time,chapter_updatetime,chapter_new,chapter_words,chapter_preview from ".__TAB_CHAPTER__." where book_id='$bid' order by chapter_orderid desc limit $limit";
$result_chapters=$db->query($sql);
while($rows_chapters=$db->fetch_row($result_chapters)) {
	$chapterlistblock[]=array(
		'G_style' => $Global['style'],
		'C_orderid' => $rows_chapters['chapter_orderid'],
		'C_typeid' => $rows_book['type_id'],
		'C_bookid' => $bid,
		'C_chaptertitle' => $rows_chapters['chapter_title'],
		'C_posttime' => gmdate("n-j",$rows_chapters['chapter_time']),
		'C_updatetime' => $rows_chapters['chapter_updatetime'] ? gmdate("n-j",$rows_chapters['chapter_updatetime']) : '无',
		'C_size' => number_format($rows_chapters['chapter_words']/1000,2),
		'C_charge' => $rows_chapters['chapter_new']?'<font color=red>收费</font>':'免费',
		'C_preview' => $rows_chapters['chapter_preview'],
		'C_previewmost' => strip_tags(printcodes(csubstr($rows_chapters['chapter_preview'],0,50))),
		'C_chapterid' => $rows_chapters['chapter_id']
	);
}

$sql="select volume_id,volume_name,volume_chapterorderid from ".__TAB_VOLUME__." where book_id='$bid' order by volume_chapterorderid";
$result_volumes=$db->query($sql);
while($rows_volumes=$db->fetch_row($result_volumes)) {
	$volumesblock[]=array(
		'G_style' => $Global['style'],
		'C_volumename' => $rows_volumes['volume_name'],
		'C_orderid' => $rows_volumes['volume_chapterorderid'],
		'C_volumeid' => $rows_volumes['volume_id']
	);
}
$db->free_result($result_volumes);//释放mysql


$tpl->assign(array(
	'C_bookid' => $bid,
	'C_bookactive' => ($rows_book['book_state']==1 ? 1:0),
	'C_booktitle' => $rows_book['book_title'],
	'C_typeid' => $rows_book['type_id'],
	'chapterlistblock' => $chapterlistblock,
	'volumesblock' => $volumesblock,
	'C_pagelink' => $pagelink
));
unset($chapterlistblock);
unset($volumesblock);

$tpl->output();

include_once AROOT."include/footer.inc.php";

?>