<?php
/*
	[Read8] bookroom.php

	Version: 3.1
	Name:公开书库程序
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-1-16 12:02
*/
include_once "./include/init.php";

//设定搜索关键词
$seokeyword[]='公开书库';
getheader($seokeyword);//输出头部

$showwhat=$initial? "按字母排序": ($author ? "作家专栏" : ($skey ? "搜索结果" : ($aclass ? "显示分类为".$aclass : ($states ? "全书完" : "全部公开作品"))));

$tpl = new Template('bookroom');
$tpl->assign($Global['main_assign']);
$tpl->assign(array(
	'C_Showwhat' => $showwhat
));


//传入变量判断
$objPage = new Page;
$objPage->setVar(array(
	"aclass"=>$aclass,
	"initial"=>$initial,
	"stype"=>$stype,
	"skey"=>$skey,
	"states"=>$states,
	"author"=>$author
));
$sqladd=$author ? " and b.book_author='$author' " : '';
if(in_array($stype,array('book_title','book_author','book_actor')) && !empty($skey)) {
	$sqladd=" and b.$stype like '%$skey%'";	
}

$sqladd.=is_numeric($initial)? " and b.book_initial between 0 and 9":($initial? " and b.book_initial='$initial' " : '');
$sqladd.=$aclass? " and b.type_id='$aclass' " : '';
$sqladd.=$states? " and b.book_state=0 " : '';

//查询列表数目
include_once AROOT.'data/cache/cache_bookmain.php';
if($states || $initial || $author || $stype) {
	$sql="select b.book_id from ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id where c.chapter_new=0 ".$sqladd;
	$result=$db->query($sql);
	$booknum=$db->num_rows($result);
}elseif($aclass) {
	$booknum=$_RCACHE['bookmain']['bookfreenum_'.$aclass];
}else {
	$booknum=$_RCACHE['bookmain']['bookfreenum'];
}

$objPage->setPage($Global['tiplist'],$booknum,0);
$pagelink=$objPage->output(1);
$limit=$objPage->limit();
//下面开始显示列表内容
$sql="select b.book_id,b.book_title,c.chapter_time,b.book_updatetime,b.type_id,book_state,c.chapter_title,b.book_author,c.chapter_orderid,vl.volume_name from ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id where c.chapter_new=0 $sqladd order by b.book_updatetime desc limit $limit";
$result=$db->query($sql);
while($rows=$db->fetch_row($result)){
	$Booklistblock[]=array(
		'G_style' => $Global['style'],
		'C_typename' => csubstr($_RCACHE['booktypebytid'][$rows['type_id']],0,4),
		'C_bookid' => $rows['book_id'],
		'C_booktitle' => $rows['book_title'],
		'C_updatetime' => gmdate("n-j",$rows['book_updatetime']),
		'C_volumetitle' => $rows['volume_name'],
		'C_typeid' => $rows['type_id'],
		'C_orderid' => $rows['chapter_orderid'],
		'C_chaptertitle' => $rows['chapter_title'],
		'C_author' => $rows['book_author'],
		'C_state' => ($rows['book_state']==1 ? '连载中' : ($rows['book_state']==2 ? '暂停中' : '全书完'))
	);
}
$db->free_result($result);//释放mysql
$tpl->assign('Booklistblock',$Booklistblock);
$tpl->assign('C_pagelink',$pagelink);
unset($Booklistblock);

//排行榜导入
$theborders=array("Thisweektopblock","Allbooktopblock");
foreach($theborders as $val){
	include_once AROOT."data/cache/cache_$val.php";
	$tpl->assign($val,$$val);
	unset($$val);
}


$tpl->output();

include_once AROOT."include/footer.inc.php";
?>