<?php
/*
	[Read8] chaptered.php

	Version: 3.1
	Name:章节添加/章节修改程序
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-2-22 16:28
*/
include_once "./include/init.php";
include_once AROOT.'include/booked.func.php';
include_once AROOT.'include/image.func.php';

//权限判断
if(!haspriv(9) && !haspriv(1) && !haspriv(2)) back('无作品管理权限');
if($cid || is_array($delchapterarr)) {//章节修改&删除
	$sql="select book_id from ".__TAB_CHAPTER__." where chapter_id='".($cid?$cid:$delchapterarr[0])."'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$bid=$rows['book_id'];
}
$sql="select book_title,type_id,user_name,book_author from ".__TAB_BOOK__." where book_id='".($pbid?$pbid:$bid)."'";
$result=$db->query($sql);
$rows=$db->fetch_row($result);
if(!haspriv(9) && $Global['F_username']<>$rows['user_name'] && $Global['F_username']<>$rows['book_author']) back('没有该书章节发布和管理权限');
$book_title=$rows['book_title'];
$type_id=$rows['type_id'];
$book_author=$rows['book_author'];

//章节删除
if(is_array($delchapterarr)) {
	if(!haspriv(20)) back('您没有作品删除权限');
	//检查是否超过每日删除上限
	$sql="select * from ".__TAB_ACTLOG__." where user_name='".$Global['F_username']."' and actlog_act like '%删除章节%' and actlog_time>".$Global['F_tdtime'];
	$result=$db->query($sql);
	$delnums=count($delchapterarr);
	$delednum=$db->num_rows($result)+$delnums;
	if($delednum>$Global['delchapterfreq'] && $Global['F_groupid']<>$Global['Rootgroupid']) back('章节删除超过每日上限'.$Global['delchapterfreq']);

	$dir="html/$type_id/$bid/";
	foreach($delchapterarr as $cid){
		//删除附件
		$sql="select * from ".__TAB_ATTACH__." where chapter_id='$cid' and book_id='$bid'";
		$result=$db->query($sql);
		while($rows=$db->fetch_row($result)){
			@unlink(AROOT.'upload/'.$rows['attach_id'].'.'.$rows['attach_filekind']);
		}
		$sql="select chapter_title,chapter_orderid from ".__TAB_CHAPTER__." where chapter_id='$cid'";
		$result=$db->query($sql);
		$rows=$db->fetch_row($result);
		$ordercid=$rows['chapter_orderid'];//章节序号id
		$ochapter=$rows['chapter_title'];
		$sql="delete from ".__TAB_CHAPTER__." where chapter_id='$cid'";
		$db->query($sql);
		
		UpdateBookcid($bid);//更新书籍的最新章节id

		unlink(AROOT.$dir.$ordercid.".html");

		//更新该章节后的所有章节的静态页面
		Renamebat($ordercid+1, AROOT.$dir, false);

		//修改数据库
		$sql="update ".__TAB_CHAPTER__." set chapter_orderid=chapter_orderid-1 where chapter_orderid>'$ordercid' and book_id='$bid'";
		$db->query($sql);
		$sql="update ".__TAB_VOLUME__." set volume_chapterorderid=volume_chapterorderid-1 where volume_chapterorderid>'$ordercid' and book_id='$bid'";
		$db->query($sql);
	}

	//书籍主页重生成
	reindex($bid);

	//增加日志记录
	if($delnums>1) {
		$logcon="批量删除章节<{$book_title}共{$delnums}章>";
	}else {
		$logcon="删除章节<{$book_title}-$ochapter_title>";
	}
	addlog($logcon);

	jumpage("booked.php?bid=$bid","章节删除成功");

}

//提交内容($cid是章节唯一id/$orderid为章节序号id)
if($pbid) {
	if($_FILES['attachnew']['tmp_name']) {
		$attach=$_FILES['attachnew']['tmp_name'];
		$attach_name=$_FILES['attachnew']['name'];
		$attach_size=$_FILES['attachnew']['size'];
		foreach($attach as $key=>$val){
			if(empty($val)) continue;
			if(!$Global['allow_upload']) back('禁止上传附件');
			$filename=substr($attach_name[$key],0,strrpos($attach_name[$key],"."));
			$filetype=strtolower(substr($attach_name[$key],strrpos($attach_name[$key],".")+1));
			if(!ereg("^php[0-9A-Za-z_.-]+$",basename($val))) back('附件名错误');
			if($attach_size[$key]>$Global['max_upload_size']) back('附件大小超限');
			if(!in_array($filetype,$Global['upload_type_available'])) back('文件类型被禁止');
		}
	}
	$sql="select type_id,book_title,book_author from  ".__TAB_BOOK__." where book_id='$pbid'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$type_id=$rows['type_id'];
	$book_title=$rows['book_title'];
	$book_author=$rows['book_author'];
	$dir="html/$type_id/$pbid/";

	$words=intval(strlen($chaptercontent)/2);
	$chaptertitle=trim($chaptertitle);
	$chaptercontent=rtrim($chaptercontent);
	
	if($midinsert) {//中间插入处理必须的其他处理
		if($cid) {//-------------------类型为章节修改-------------------------------------
			$sql="select chapter_orderid from ".__TAB_CHAPTER__." where chapter_id='$cid'";
			$result=$db->query($sql);
			$rows=$db->fetch_row($result);
			$orderid=$rows['chapter_orderid'];
			unlink(AROOT.$dir.$orderid.".html");
			
			//更新所修改章节的插入变动中间的影响章节
			RenameAreabat($orderid, $icid+1 , AROOT.$dir);

			//修改mysql
			$movepos=($icid<$orderid) ? 1:-1;//为正时是向后移动，为负是向前移动
			$sql="update ".__TAB_CHAPTER__." set chapter_orderid=chapter_orderid+$movepos where chapter_orderid between ".min($icid+1,$orderid)." and ".max($icid+1,$orderid)." and book_id='$pbid'";
			$db->query($sql);
			$sql="update ".__TAB_VOLUME__." set volume_chapterorderid=volume_chapterorderid+$movepos where volume_chapterorderid between ".min($icid+1,$orderid)." and ".max($icid+1,$orderid)." and book_id='$pbid'";
			$db->query($sql);

		}else {//-------------------类型为章节新建-----------------------------------------
			//更新插入章节后的所有章节的静态页面
			Renamebat($icid+1, AROOT.$dir, true);

			//修改数据库
			$sql="update ".__TAB_CHAPTER__." set chapter_orderid=chapter_orderid+1 where chapter_orderid>'$icid' and book_id='$pbid'";
			$db->query($sql);
			$sql="update ".__TAB_VOLUME__." set volume_chapterorderid=volume_chapterorderid+1 where volume_chapterorderid>'$icid' and book_id='$pbid'";
			$db->query($sql);
		}

		$newchapterid=$icid+1;//新章节的顺序id

	}else {//非插入的章节提交
		if($cid) {//-------------------类型为章节修改-------------------------------------
			$sql="select chapter_orderid from ".__TAB_CHAPTER__." where chapter_id='$cid'";
			$result=$db->query($sql);
			$rows=$db->fetch_row($result);
			$newchapterid=$rows['chapter_orderid'];//新章节的顺序id
		}else {//-------------------类型为章节新建-----------------------------------------
			$sql="select max(chapter_orderid) as maxorderid from ".__TAB_CHAPTER__." where book_id='$pbid'";
			$result=$db->query($sql);
			$rows=$db->fetch_row($result);
			$newchapterid=$rows['maxorderid']+1;//新章节的顺序id
		}
	}

	//增加卷
	if($addvolume && $newvolumename) {
		$sql="insert into ".__TAB_VOLUME__." set book_id='$pbid',volume_name='$newvolumename',volume_chapterorderid='$newchapterid'";
		$db->query($sql);
	}
	//得到卷id
	$sql="select volume_id from ".__TAB_VOLUME__." where book_id='$pbid' and volume_chapterorderid<'".($newchapterid+1)."' order by volume_chapterorderid desc limit 1";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$volumid=intval($rows['volume_id']);
	$tmpurl= ($charge && haspriv(2)) ? md5(time().rand(1,100)):'';

	//提交章节mysql处理
	$sql="insert into ".__TAB_CHAPTER__." set chapter_title='$chaptertitle',book_id='$pbid',chapter_orderid='$newchapterid',chapter_time='".$Global['F_time']."', chapter_new='".($tmpurl?1:0)."',chapter_words='$words',chapter_tmpurl='$tmpurl',chapter_preview='$chapterviewcontent',volume_id='$volumid',chapter_md5='".md5($chaptertitle)."'";
	if($cid) $sql="update ".__TAB_CHAPTER__." set chapter_title='$chaptertitle',chapter_orderid='$newchapterid',chapter_updatetime='".$Global['F_time']."', chapter_new='".($tmpurl?1:0)."',chapter_words='$words',chapter_tmpurl='$tmpurl',chapter_preview='$chapterviewcontent',volume_id='$volumid',chapter_md5='".md5($chaptertitle)."' where chapter_id='$cid'";
	$db->query($sql);
	$abschapterid= $cid ? $cid : $db->nextid() ;//章节绝对id

	//---------附件管理---------------
	$addattachcon='';
	$oldattacharr=$hitsarr=array();
	if($cid) {//已有附件的更新
		$sql="select * from ".__TAB_ATTACH__." where chapter_id='$cid'";
		$result=$db->query($sql);
		while($rows=$db->fetch_row($result)) {
			$key=$rows['attach_id'];
			if($attachaction[$key]=='keep') continue;
			@unlink(AROOT."upload/$key.".$rows['attach_filekind']);
			$sql='delete from '.__TAB_ATTACH__." where attach_id='$key'";
			$db->query($sql);
			if($attachaction[$key]=='new') {//更新附件
				$tmpattach=$_FILES['attachnew']['tmp_name'][$key];
				$tmpattach_name=$_FILES['attachnew']['name'][$key];
				$tmpattach_size=$_FILES['attachnew']['size'][$key];
				$filename=substr($tmpattach_name,0,strrpos($tmpattach_name,"."));
				$filetype=strtolower(substr($tmpattach_name,strrpos($tmpattach_name,".")+1));
				@move_uploaded_file($tmpattach,AROOT."upload/$key.$filetype");
				if(in_array($filetype,array('jpg','jpeg')) && $Global['imgmark']) addmark(AROOT."upload/$key.$filetype");
				$sql="insert into ".__TAB_ATTACH__." set attach_id='$key',book_id='$pbid',chapter_id='$cid',attach_date='$Global[F_time]', attach_filename='$filename',attach_filekind='$filetype',attach_filesize='$tmpattach_size',attach_hits='".$rowsat['attach_hits']."'";
				$db->query($sql);
				//增加内容中的附件链接
				if(!strstr($chaptercontent,"[attach]{$key}[/attach]")) $addattachcon.="\r\n[attach]{$key}[/attach]";
			}else {
				$chaptercontent=str_replace("[attach]{$key}[/attach]",'',$chaptercontent);
			}
			unset($_FILES['attachnew']['tmp_name'][$key]);//删除更新完的附件,避免影响下步foreach
		}
	}
	//新的附件
	foreach($_FILES['attachnew']['tmp_name'] as $key=>$val){
		if(empty($val)) continue;
		$tmpattach_name=$_FILES['attachnew']['name'][$key];
		$tmpattach_size=$_FILES['attachnew']['size'][$key];
		$filename=substr($tmpattach_name,0,strrpos($tmpattach_name,"."));
		$filetype=strtolower(substr($tmpattach_name,strrpos($tmpattach_name,".")+1));
		$sql="insert into ".__TAB_ATTACH__." set book_id='$pbid',chapter_id='$abschapterid',attach_date='$Global[F_time]', attach_filename='$filename',attach_filekind='$filetype',attach_filesize='$tmpattach_size'";
		$db->query($sql);
		$tmpname=$db->nextid();
		@move_uploaded_file($val,AROOT."upload/$tmpname.$filetype");
		if(in_array($filetype,array('jpg','jpeg')) && $Global['imgmark']) addmark(AROOT."upload/$tmpname.$filetype");
		if(!strstr($chaptercontent,"[attach]{$tmpname}[/attach]")) $addattachcon.="\r\n[attach]{$tmpname}[/attach]";
	}

	//添加章节文件
	if($tmpurl) {//收费章节
		//图片生成
		MakeVipImage($chaptercontent, AROOT."data/vip/$tmpurl.jpg");
		
		//章节临时网页生成
		$shopurl="$Global[siteurl]/shopinfo.php?cid=$abschapterid";
		$loginurl="$Global[siteurl]/login.php?forward=".urlencode($shopurl);
		$vippayurl="$Global[siteurl]/mobilepay.php";
		$vipcontent="<div id=\"vip\"><img src=\"$Global[siteurl]/vip.php?bid=$pbid&oid=$newchapterid\" usemap=\"#Face\" alt=\"\" /></div><map name=\"Face\" id=\"Face\"><area shape=\"rect\" href=\"$shopurl\" coords=\"$Global[vipdeny_shoparea]\" alt=\"放入购物车\" /><area shape=\"rect\" href=\"$loginurl\" coords=\"$Global[vipdeny_loginarea]\" alt=\"登录\" /><area shape=\"rect\" href=\"$vippayurl\" coords=\"$Global[vipdeny_vippayarea]\" alt=\"购买结帐\" /></map>";//增加map热点供点击

		$tpl = new Template('/../../html/template/content');
		$tpl->assign($Global['main_assign']);
		$tpl->assign(array(
			'C_chaptertitle' => $chaptertitle,
			'C_booktitle' => $book_title,
			'C_authorname' => $book_author,
			'C_bookid' => $pbid,
			'C_lchapterid' => $newchapterid-1,
			'C_nchapterid' => $end ? '' : $newchapterid+1,
			'C_tchapterid' => $newchapterid,
			'C_content' => $vipcontent,
		));
		writetofile(AROOT.$dir.$newchapterid.".html", $tpl->result());

		$resultfile=AROOT."data/vip/$tmpurl.html";
	}else {
		$resultfile=AROOT.$dir.$newchapterid.".html";
	}
	//增加附件内容
	$chaptercontent.=$addattachcon;

	//章节网页生成
	$tpl = new Template('/../../html/template/content');
	$tpl->assign($Global['main_assign']);
	$tpl->assign(array(
		'C_chaptertitle' => stripslashes($chaptertitle),
		'C_booktitle' => $book_title,
		'C_authorname' => $book_author,
		'C_bookid' => $pbid,
		'C_lchapterid' => $newchapterid-1,
		'C_nchapterid' => $end ? '' : $newchapterid+1,
		'C_tchapterid' => $newchapterid,
		'C_content' => UbbDecode(HtmlFormat(stripslashes($chaptercontent))),
	));
	writetofile($resultfile, $tpl->result());

	//书籍更新mysql
	$sqladd= $end ? ",book_state=0 ":'';
	$words= $cid ? 0:$words;
	$sql="update ".__TAB_BOOK__." set book_updatetime='".$Global['F_time']."',book_newchapterid='$abschapterid',book_size=book_size+".$words.$sqladd." where book_id='$pbid'";
	$db->query($sql);

	TidyVolume($pbid);//章节表的卷重新生成

	reindex($pbid);

	$worksos=$cid?"修改":"添加";
	jumpage("chaptered.php?bid=$pbid", $worksos."成功");
}


//显示章节内容
$tpl = new Template('chaptered');
$tpl->assign($Global['main_assign']);

$sql="select chapter_orderid,book_title,chapter_title,book_author,type_id,volume_name,book_state from  ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id where b.book_id='$bid'";
$result=$db->query($sql);
$rows=$db->fetch_row($result);
$book_title=$rows['book_title'];
$book_author=$rows['book_author'];
$type_id=$rows['type_id'];
$lastchapter_orderid=$rows['chapter_orderid'];
$lastchapter_title=$rows['chapter_title'];
$lastvolume_name=$rows['volume_name'];
$book_state=$rows['book_state'];

//设定搜索关键词
$seokeyword[]='章节管理';
$seokeyword[]=$chapter_title;
$seokeyword[]=$book_title;
getheader($seokeyword);//输出头部

$attachblock=array();
if($cid) {//章节修改
	//附件显示
	$sql='select * from '.__TAB_ATTACH__." where chapter_id='$cid'";
	$result=$db->query($sql);
	while($rows=$db->fetch_row($result)){
		$attachblock[]=array(
			'C_attachmentid' => $rows['attach_id'],
			'C_filename' => $rows['attach_filename'],
			'C_filekind' => $rows['attach_filekind'],
		);
	}
	//内容显示
	$sql="select chapter_title,chapter_orderid,chapter_new,chapter_tmpurl,chapter_preview from ".__TAB_CHAPTER__." where chapter_id='$cid'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$thischapter_title=$rows['chapter_title'];
	$thischapter_new=$rows['chapter_new'];
	$thischapter_preview=$rows['chapter_preview'];
	if($rows['chapter_new'] && $rows['chapter_tmpurl']) $chapterfile=AROOT."data/vip/".$rows['chapter_tmpurl'].".html";
	else $chapterfile=AROOT."html/$type_id/$bid/".$rows['chapter_orderid'].".html";
	$chaptercontent=GetContent($chapterfile);
	$chaptercontent=EditFormat($chaptercontent);//html格式转换为可编辑格式
	$chaptercontent=UbbEncode($chaptercontent);//ubb反转换
}else {
	$chaptercontent='    '.$chaptercontent;
}

$sql="select chapter_orderid,chapter_title from ".__TAB_CHAPTER__." where book_id='$bid' order by chapter_orderid";
$result=$db->query($sql);
while($rows=$db->fetch_row($result)) {
	$icoption.="<option value=".$rows['chapter_orderid'].">".$rows['chapter_title']."</option>";
}
$db->free_result($result);//释放mysql


$tpl->assign(array(
	'C_lastorderid' => $lastchapter_orderid,
	'C_lastvolumetitle' => $lastvolume_name,
	'C_lastchaptertitle' => $lastchapter_title,
	'C_typeid' => $type_id,
	'C_bookid' => $bid,
	'C_booktitle' => $book_title,
	'C_chaptername' => $thischapter_title,
	'C_chapterid' => $cid,
	'C_checked' => $thischapter_new ? 'checked="checked"':'',
	'C_endchecked' => $book_state ? '':'checked="checked"',
	'C_disabled' => haspriv(2) ? '':'disabled="disabled"',
	'icoption' => $icoption,
	'C_chapterviewcontent' => $thischapter_preview,
	'C_chaptercontent' => $chaptercontent,
	'upload_type_available' => implode(" ",$Global['upload_type_available']),
	'attachblock' => $attachblock,
));

$tpl->output();


include_once AROOT."include/footer.inc.php";
?>