<?php
/*
	[Read8] dataquote.php

	Version: 3.1
	Name:数据引用程序
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-10-18 19:24
*/

include_once "./include/init.php";

if(empty($kind) && empty($type)) die('document.write("<span style=\"color: Red;\">Bad Request. Please choose a method.</span>");');
if(!in_array($kind,array('vip','yuanchuang','zhuanzai',)) && !isset($_RCACHE['booktypebytid'][$type])) die('document.write("<span style=\"color: Red;\">Bad Request. Please check your arguments.</span>");');
$wblock='';
switch($kind) {
	case 'vip':
		$sql="SELECT b.book_id,book_title,chapter_time,book_updatetime,type_id,chapter_title,book_author,chapter_id AS cid,volume_name FROM ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON c.chapter_id=b.book_newchapterid LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id WHERE chapter_new=1 ORDER BY book_updatetime DESC LIMIT ".$Global['indextiplist'];
		break;
	case 'yuanchuang':
		$sql="SELECT b.book_id,book_title,chapter_time,book_updatetime,type_id,chapter_title,book_author,chapter_orderid AS cid,volume_name FROM ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id WHERE chapter_new=0 AND b.book_attrib='原创作品' ORDER BY book_updatetime DESC LIMIT ".$Global['indextiplist'];
		break;
	case 'zhuanzai':
		$sql="SELECT b.book_id,book_title,chapter_time,book_updatetime,type_id,chapter_title,book_author,chapter_orderid AS cid,volume_name FROM ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id WHERE chapter_new=0 AND b.book_attrib<>'原创作品' ORDER BY book_updatetime DESC LIMIT ".$Global['indextiplist'];
		break;
	default:
		$sql="SELECT b.book_id,book_title,chapter_time,book_updatetime,type_id,chapter_title,book_author,chapter_orderid AS cid,volume_name FROM ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id WHERE chapter_new=0 AND b.type_id='$type' ORDER BY book_updatetime DESC LIMIT ".$Global['indextiplist'];
}

$result=$db->query($sql);
while($rows=$db->fetch_row($result)) {
	$wblock[]=array(
		'C_bookid' => $rows['book_id'],
		'C_typeid' => $rows['type_id'],
		'C_typename' => csubstr($_RCACHE['booktypebytid'][$rows['type_id']],0,4),
		'C_booktitle' => $rows['book_title'],
		'C_author' => $rows['book_author'],
		'C_posttime' => gmdate("m-d",$rows['chapter_time']),
		'C_chapterid' => $rows['cid'],
		'C_volumetitle' => $rows['volume_name'],
		'C_chaptertitle' => $rows['chapter_title'],
	);
}
$db->free_result($result);

if(!is_array($wblock)) die('document.write("<span style=\"color: Red;\">Bad Request. No data can quote.</span>");');
if(!empty($charset) && $charset != $Global['encode']) $wblock=utf82gbk($wblock,$charset);
?>
document.writeln("<style type=\"text/css\" />");
document.writeln(".update div.content {background-color: #F7F7F7;margin-top: 1px;width: 100%;padding: 5px 0;}");
document.writeln(".update div div.left {float: left;margin-left: 3px;width: 70%;}");
document.writeln(".update div div.right {text-align: right;float: right;margin-right: 3px;width: 20%;}");
document.writeln("</style>");
document.writeln("<div class=\"update\">");
<?php
foreach($wblock as $val) {
	echo 'document.writeln("<div class=\"content\">");';
	echo 'document.writeln("<div class=\"left\">&nbsp;['.$val['C_typename'].']&nbsp;<a href=\"'.$Global['siteurl'].'/bookinfo.php?bid='.$val['C_bookid'].'\" rel=\"external\"><span style=\"color: Green;\">'.$val['C_booktitle'].'</span></a>&nbsp;&nbsp;");';
	switch($kind) {
		case 'vip':
			echo 'document.writeln("<a href=\"'.$Global['siteurl'].'/shopinfo.php?cid='.$val['C_chapterid'].'\" rel=\"external\"><span style=\"color: Gray;\">'.$val['C_volumetitle'].'</span>&nbsp;<span style=\"color: Gray;\">'.$val['C_chaptertitle'].'</span></a></div>");';
			break;
		default:
			echo 'document.writeln("<a href=\"'.$Global['siteurl'].'/html/'.$val['C_typeid'].'/'.$val['C_bookid'].'/'.$val['C_chapterid'].'.html\" rel=\"external\"><span style=\"color: Gray;\">'.$val['C_volumetitle'].'</span>&nbsp;<span style=\"color: Gray;\">'.$val['C_chaptertitle'].'</span></a></div>");';
			break;
	}
	echo 'document.writeln("<div class=\"right\"><a href=\"'.$Global['siteurl'].'/authorinfo.php?target='.$val['C_author'].'\" rel=\"external\"><span style=\"color: Green;\">'.$val['C_author'].'</span></a>&nbsp;&lt;'.$val['C_posttime'].'&gt;</div>");';
	echo 'document.writeln("</div>");';
}
unset($wblock);
?>document.writeln("</div>");<?php
function utf82gbk($string,$charset){
	global $Global;
	if(is_array($string)) {
		foreach($string as $key => $val) {
			$string[$key] = utf82gbk($val,$charset);
		}
	}else {
		$string = mb_convert_encoding($string,$charset,$Global['encode']);
	}
	return $string;
}
?>