<?php

class Template{
		function Template ($template_filename){
			global $Global;
			$this->temp_dir = AROOT.'data/cache/';
			$this->tpl_file = AROOT.'template/'.$Global['style'].'/'.$template_filename.'.html';
		}
		function assign ( $name, $value = '' ){
			if (is_array($name)){
				foreach ($name as $k => $v)	{
					$this->data[$k]  =  $v;
				}
			}else{
				$this->data[$name]  =  $value;
			}
		}
		function result ()
		{
			ob_start();
			$this->output();
			$result  =  ob_get_contents(); 
			ob_end_clean();
			return $result;
		}
		function output (){
			$_top  =  $this->data;
			$_obj  =  &$_top;
			$_stack_cnt  =  0;
			$_stack[$_stack_cnt++]  =  $_obj;
			//	Check if template is already compiled
	    	$this->cpl_file  =  $this->temp_dir . preg_replace('/[:\/.\\\\]/', '_', $this->tpl_file) . '.php';
			$compile_template  =  true;
			if ($this->reuse_code){
				if (is_file($this->cpl_file)){
					if ($this->mtime($this->cpl_file) > $this->mtime($this->tpl_file)){
						$compile_template  =  false;
					}
				}
			}
			if ($compile_template){
				$this->parser = new SmartTemplateParser($this->tpl_file);
				if (!$this->parser->compile($this->cpl_file)){
					exit( "模板编译错误: " . $this->parser->error );
				}
			}
			include($this->cpl_file);
			unset ($GLOBALS[_top]);
		}
		function mtime ( $filename ){
			if (@is_file($filename)){
				return filemtime($filename);
			}
		}
}

class SmartTemplateParser{
		function SmartTemplateParser ( $template_filename )	{
			//	Load Template
	        if ($hd  =  @fopen($template_filename,  "r")){
		        $this->template  =  fread($hd,  filesize($template_filename));
		        fclose($hd);
		    }else{
		    	$this->template  =  "找不到文件: '$template_filename'";
		    }
		}
		function compile( $compiled_template_filename = '' ){
			if (empty($this->template)){
				return;
			}
			//	END, ELSE Blocks
			$page  =  preg_replace("/<!-- ENDIF.+?-->/",  "<?php\n}\n?>",  $this->template);
			$page  =  preg_replace("/<!-- END[ a-zA-Z0-9_.]* -->/",  "<?php\n}\n\$_obj=\$_stack[--\$_stack_cnt];}\n?>",  $page);
			$page  =  str_replace("<!-- ELSE -->",  "<?php\n} else {\n?>",  $page);
			//	'BEGIN - END' Blocks
			if (preg_match_all('/<!-- BEGIN ([a-zA-Z0-9_.]+) -->/', $page, $var)){
				foreach ($var[1] as $tag){
					list($parent, $block)  =  $this->var_name($tag);
					$code  =  "<?php\n"
							. "if (!empty(\$$parent"."['$block'])){\n"
							. "if (!is_array(\$$parent"."['$block']))\n"
							. "\$$parent"."['$block']=array(array('$block'=>\$$parent"."['$block']));\n"
							. "\$_tmp_arr_keys=array_keys(\$$parent"."['$block']);\n"
							. "if (\$_tmp_arr_keys[0]!='0')\n"
							. "\$$parent"."['$block']=array(0=>\$$parent"."['$block']);\n"
							. "\$_stack[\$_stack_cnt++]=\$_obj;\n"
							. "foreach (\$$parent"."['$block'] as \$rowcnt=>\$$block) {\n"
							. "\$$block"."['ROWCNT']=\$rowcnt;\n"
							. "\$$block"."['ALTROW']=\$rowcnt%2;\n"
							. "\$$block"."['ROWBIT']=\$rowcnt%2;\n"
							. "\$_obj=&\$$block;\n?>";
					$page  =  str_replace("<!-- BEGIN $tag -->",  $code,  $page);
				}
			}
			//	'IF nnn="mmm"' Blocks
			if (preg_match_all('/<!-- (ELSE)?IF ([a-zA-Z0-9_.]+)([!=<>]+)"([^"]*)" -->/', $page, $var)){
				foreach ($var[2] as $cnt => $tag){
					list($parent, $block)  =  $this->var_name($tag);
					$cmp   =  $var[3][$cnt];
					$val   =  $var[4][$cnt];
					$else  =  ($var[1][$cnt] == 'ELSE') ? '} else' : ''; 
					if ($cmp == '=') $cmp  =  '==';
					$code  =  "<?php\n$else"."if (\$$parent"."['$block'] $cmp \"$val\"){\n?>";
					$page  =  str_replace($var[0][$cnt],  $code,  $page);
				}
			}
			//	'IF nnn' Blocks
			if (preg_match_all('/<!-- (ELSE)?IF ([a-zA-Z0-9_.]+) -->/', $page, $var)){
				foreach ($var[2] as $cnt => $tag){
					$else  =  ($var[1][$cnt] == 'ELSE') ? '} else' : ''; 
					list($parent, $block)  =  $this->var_name($tag);
					$code  =  "<?php\n$else"."if (!empty(\$$parent"."['$block'])){\n?>";
					$page  =  str_replace($var[0][$cnt],  $code,  $page);
				}
			}
			//	Replace Scalars
			if (preg_match_all('/{([a-zA-Z0-9_. >]+)}/', $page, $var)){
				foreach ($var[1] as $fulltag){
					//	Determin Command (echo / $obj[n]=)
					list($cmd, $tag)  =  $this->cmd_name($fulltag);
					list($block, $skalar)  =  $this->var_name($tag);
					$code  =  "<?php\n$cmd \$$block"."['$skalar'];\n?>\n";
					$page  =  str_replace('{'.$fulltag.'}',  $code,  $page);
				}
			}
			//	Add Include Header
			if ($header){
				$page  =  "<?php\n$header\n?>$page";
			}
			//	Store Code to Temp Dir
			if (strlen($compiled_template_filename)){
		        if ($hd  =  fopen($compiled_template_filename,  "w")){
			        fwrite($hd,  $page);
			        fclose($hd);
			        return true;
			    }else{
			    	$this->error  =  "不能写入缓存文件夹.<script type=\"text/javascript\">location.reload();</script>";
			        return false;
			    }
			}else{
				return $page;
			}
		}
		function var_name($tag){
			$parent_level  =  0;
			while (substr($tag, 0, 7) == 'parent.'){
				$tag  =  substr($tag, 7);
				$parent_level++;
			}
			if (substr($tag, 0, 4) == 'top.'){
				$obj  =  '_stack[0]';
				$tag  =  substr($tag,4);
			}elseif ($parent_level){
				$obj  =  '_stack[$_stack_cnt-'.$parent_level.']';
			}else{
				$obj  =  '_obj';
			}
			while (is_int(strpos($tag, '.'))){
				list($parent, $tag)  =  explode('.', $tag, 2);
				if (is_numeric($parent)){
					$obj  .=  "[" . $parent . "]";
				}else{
					$obj  .=  "['" . $parent . "']";
				}
			}
			return array($obj, $tag);
		}
		function cmd_name($tag){
			if (preg_match('/^(.+) > ([a-zA-Z0-9_.]+)$/', $tag, $tagvar)){
				$tag  =  $tagvar[1];
				list($newblock, $newskalar)  =  $this->var_name($tagvar[2]);
				$cmd  =  "\$$newblock"."['$newskalar']=";
			} else {
				$cmd  =  "echo";
			}
			return array($cmd, $tag);
		}

}
?>