<?php
/*
	[Read8] shop.php

	Version: 3.1
	Name:电子书库
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-1-16 12:02
*/

include_once "./include/init.php";
include_once("./include/ShoppingCart.cls.php");

$objMyCart = new Cart();
if($buycid){
	$oldurl = $_SERVER['REQUEST_URI'] ? str_replace($buycid,'',$_SERVER['REQUEST_URI']) : 'shop.php';
	$sql="select buylist_id from ".__TAB_BUYLIST__." where chapter_id='$buycid' and user_name='".$Global['F_username']."'";
	$result=$db->query($sql);
	if($rows=$db->fetch_row($result)) {
		jumpage($oldurl,"您已经购买过此章节了");
	}
	$sql = "select c.book_id,book_title,chapter_words,chapter_title,chapter_orderid,volume_name from ".__TAB_CHAPTER__." c LEFT JOIN ".__TAB_BOOK__." b ON b.book_id=c.book_id LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id where chapter_new=1 and chapter_id='$buycid'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$objMyCart->addToCart($buycid,$rows['book_title'].'-'.$rows['volume_name'].'-'.$rows['chapter_title'],ceil($rows['chapter_words']/1000)*$Global['vipbookprice']);
	jumpage($oldurl,"添加成功 ");
}
if($delcid){
	$objMyCart->rmFromCart($delcid);
	$oldurl = $_SERVER['REQUEST_URI'] ? str_replace($buycid,'',$_SERVER['REQUEST_URI']) : 'shop.php';
	jumpage($oldurl,"删除成功 ");
}


//设定搜索关键词
$seokeyword[]='电子书库';
getheader($seokeyword);//输出头部

if($arrMyCart = $objMyCart->getCart()){
	foreach($arrMyCart as $cartKey => $cartValue){
		$cartblock[]=array(
			'G_style' => $Global['style'],
			'C_chapterid' => $cartValue['buyID'],
			'C_chaptername' => $cartValue['chapter'],
			'C_price' => $cartValue['price']
		);
	}
}

$showwhat=$initial? "按字母排序": ($author ? "作家专栏" : ($skey ? "搜索结果" : ($aclass ? "显示分类为".$_RCACHE['booktypebytid'][$aclass] : "全部公开作品")));

$tpl = new Template('shop');
$tpl->assign($Global['main_assign']);
$tpl->assign(array(
	'cartblock' => $cartblock,
	'C_Showwhat' => $showwhat
));


//传入变量判断
$objPage = new Page;
$objPage->setVar(array(
	"aclass"=>$aclass,
	"initial"=>$initial,
	"stype"=>$stype,
	"skey"=>$skey,
	"author"=>$author
));
$sqladd=$author ? " and b.book_author='$author' " : '';
if(in_array($stype,array('book_title','book_author','book_actor')) && !empty($skey)) {
	$sqladd=" and b.$stype like '%$skey%'";	
}

$sqladd.=is_numeric($initial)? " and b.book_initial between 0 and 9":($initial? " and b.book_initial='$initial' " : '');
$sqladd.=$aclass? " and b.type_id='$aclass' " : '';

//查询列表数目
include_once AROOT.'data/cache/cache_bookmain.php';
if($states || $initial || $author || $stype) {
	$sql="select b.book_id from ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id where chapter_new=1 ".$sqladd;
	$result=$db->query($sql);
	$booknum=$db->num_rows($result);
}elseif($aclass) {
	$booknum=$_RCACHE['bookmain']['shopnum_'.$aclass];
}else {
	$booknum=$_RCACHE['bookmain']['shopnum'];
}
$objPage->setPage($Global['tiplist'],$booknum,0);
$pagelink=$objPage->output(1);
$limit=$objPage->limit();
//下面开始显示列表内容
$sql="select b.book_id,book_title,book_updatetime,chapter_title,book_author,book_state,chapter_orderid,chapter_words,type_id,chapter_id,volume_name from ".__TAB_BOOK__." b LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id where chapter_new=1 ".$sqladd." order by book_updatetime desc limit ".$limit;
$result=$db->query($sql);
while($rows=$db->fetch_row($result)){
	$Shopconblock[]=array(
		'G_style' => $Global['style'],
		'C_bookid' => $rows['book_id'],
		'C_typeid' => $rows['type_id'],
		'C_booktitle' => $rows['book_title'],
		'C_updatetime' => gmdate("n-j",$rows['book_updatetime']),
		'C_volumetitle' => $rows['volume_name'],
		'C_chapterid' => $rows['chapter_id'],
		'C_orderid' => $rows['chapter_orderid'],
		'C_chaptertitle' => $rows['chapter_title'],
		'C_price' => ceil($rows['chapter_words']/1000)*$Global['vipbookprice'],
		'C_author' => $rows['book_author'],
		'C_state' => ($rows['book_state']==1 ? '连载中' : ($rows['book_state']==2 ? '暂停中' : '全书完'))
	);
}
$db->free_result($result);//释放mysql
$tpl->assign('Shopconblock',$Shopconblock);
$tpl->assign('C_pagelink',$pagelink);
unset($Shopconblock);

//排行榜导入
$theborders=array("Thisweektopblock","Allbooktopblock");
foreach($theborders as $val){
	include_once(AROOT."data/cache/cache_$val.php");
	$tpl->assign($val,$$val);
	unset($$val);
}


$tpl->output();

include_once AROOT."include/footer.inc.php";
?>