<?php
/*
	[Read8] worksed.php

	Version: 3.1
	Name:书籍列表/书属性编辑程序
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-7-16 17:06
*/

include_once "./include/init.php";
include_once AROOT.'include/booked.func.php';

//权限判断
if(!haspriv(9) && !haspriv(1) && !haspriv(2)) back('无作品管理权限');
if($bid) {
	$sql="select user_name,book_author,type_id,book_state,book_title from ".__TAB_BOOK__." where book_id='$bid'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	if(!haspriv(9) && $Global['F_username']<>$rows['user_name'] && $Global['F_username']<>$rows['book_author']) back('没有该书章节发布和管理权限');
}

//类别修改显示
if(is_numeric($bid) && is_numeric($typeid)) {
	$r8tmp='';
	foreach($_RCACHE['booktypebytid'] as $key=>$val){
		$r8tmp.="<option value=\"$key\"".($key==$typeid?' selected="selected"':'').">$val</option>";
	}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $Global['encode']; ?>" />
<title>书籍类别更改</title>
</head>
<body>
<div style="text-align: center;border-collapse: collapse;background: #E5ECFA; border: 1px solid #5296FF;">
	<div style="margin: 10px auto;font-weight: bold;">请选择新的书籍类别:</div>
	<form style="margin: 10px auto;" action="worksed.php">
		<input type="hidden" name="bid" value="<?php echo $bid; ?>" />
		<input type="hidden" name="otypeid" value="<?php echo $typeid; ?>" />
		<select name="newtypeid"><?php echo $r8tmp; ?></select>　<input type="submit" value="修改" />
	</form>
</div>
</body>
</html>
<?
	exit;
}elseif(is_numeric($bid) && is_numeric($otypeid) && is_numeric($newtypeid)) {
	if(!@rename(AROOT."html/$otypeid/$bid", AROOT."html/$newtypeid/$bid")) back("移动静态网页文件失败<br>从'html/$otypeid/$bid'到'html/$newtypeid/$bid'");
	$sql="update ".__TAB_BOOK__." set type_id='$newtypeid' where book_id='$bid'";
	$db->query($sql);

	$sql="update ".__TAB_BOOKFACE__." set type_id='$newtypeid' where book_id='$bid'";
	$db->query($sql);
	updatecache('bookface');

	//增加日志记录
	$sql="select book_title from ".__TAB_BOOK__." where book_id='$bid'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$logcon="更改书籍分类<".$rows['book_title']." 从'".$_RCACHE['booktypebytid'][$otypeid]."'到'".$_RCACHE['booktypebytid'][$newtypeid]."'>";
	addlog($logcon);
	echo $logcon."<font color=red>成功</font><br><br>请关闭此窗口。";
	exit;
}


//作品操作
if($bid) {
	if($newauthor) $sql="update ".__TAB_BOOK__." set book_author='".$newauthor."' where book_id='".$bid."'";
	elseif($newbookname) $sql="update ".__TAB_BOOK__." set book_title='$newbookname',book_md5='".md5($newbookname)."',book_initial='".getinitial($newbookname)."' where book_id='".$bid."'";
	elseif($newtyper) $sql="update ".__TAB_BOOK__." set user_name='".$newtyper."' where book_id='".$bid."'";
	elseif($newattrib) $sql="update ".__TAB_BOOK__." set book_attrib='".$newattrib."' where book_id='".$bid."'";
	elseif($newintro) $sql="update ".__TAB_BOOK__." set book_intro='".$newintro."' where book_id='".$bid."'";
	else $sql='';
	$db->query($sql);

	$sql="select user_name,book_author,type_id,book_state,book_title from ".__TAB_BOOK__." where book_id='".$bid."'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	//书籍文件重生成
	reindex($bid);

	jumpage("worksed.php","书籍操作成功");
}


//显示作品列表

//设定搜索关键词
$seokeyword[]='书籍列表';
getheader($seokeyword);//输出头部

$tpl = new Template('worksed');
$tpl->assign($Global['main_assign']);

$sqladd=$thename ? " and book_title like '%".trim($thename)."%' " : '';

$sql="select book_id from ".__TAB_BOOK__." where book_author='".$Global['F_username']."' or user_name='".$Global['F_username']."' ".$sqladd;
if(haspriv(9)) {
	$sqladd=$thename ? " WHERE book_title LIKE '%".trim($thename)."%' " : '';
	$sql="SELECT book_id FROM ".__TAB_BOOK__.$sqladd;
}
$result=$db->query($sql);
$booknum=$db->num_rows($result);
$objPage = new Page;
$objPage->setVar(array("bid"=>$bid));
$objPage->setPage($Global['tiplist'],$booknum,0);
$pagelink=$objPage->output(1);
$limit=$objPage->limit();

$sql="select book_id,book_title,user_name,book_author,book_intro,book_attrib,book_time,book_updatetime,book_size,book_state,type_id from ".__TAB_BOOK__." where book_author='".$Global['F_username']."' or user_name='".$Global['F_username']."' ".$sqladd." order by book_updatetime desc limit ".$limit;
if(haspriv(9)) {
	$sql="SELECT book_id,book_title,user_name,book_author,book_intro,book_attrib,book_time,book_updatetime,book_size,book_state,type_id FROM ".__TAB_BOOK__.$sqladd." ORDER BY book_updatetime DESC LIMIT ".$limit;
}
$result_books=$db->query($sql);
while($rows_books=$db->fetch_row($result_books)) {
	$Bookblock[]=array(
		'G_style' => $Global['style'],
		'C_bookid' => $rows_books['book_id'],
		'C_booktitle' => $rows_books['book_title'],
		'C_posttime' => gmdate("n-j",$rows_books['book_time']),
		'C_updatetime' => ($rows_books['book_updatetime']<>$rows_books['book_time']) ? gmdate("n-j",$rows_books['book_updatetime']) : '无',
		'C_author' => $rows_books['book_author'],
		'C_typer' => $rows_books['user_name'],
		'C_attrib' => $rows_books['book_attrib'],
		'C_typeid' => $rows_books['type_id'],
		'C_typename' => $_RCACHE['booktypebytid'][$rows_books['type_id']],
		'C_size' => number_format($rows_books['book_size']/10000),
		'C_intro' => printcodes($rows_books['book_intro']),
		'C_intromost' => printcodes(csubstr($rows_books['book_intro'],0,20)),
		'C_status' => ($rows_books['book_state']==1 ? '连载中' : ($rows_books['book_state']==2 ?'暂停中':'全书完')),
		'C_bookactive' => ($rows_books['book_state']==1 ? 1:0)
	);
}
$db->free_result($result_books);//释放mysql
$tpl->assign(array(
	'Bookblock' => $Bookblock,
	'C_pagelink' => $pagelink
));
unset($Bookblock);

$tpl->output();

include_once AROOT."include/footer.inc.php";
?>