<?php
/*
	[Read8] apply.php

	Version: 3.1
	Name:申请(新书/续费/兑换/作家)程序
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-8-12 20:22
*/

include_once "./include/init.php";
include_once(AROOT.'include/siteinfo.cfg.php');

//权限判断
checklogin();
if($action<>'pay' && $action<>'newauthor' && empty($authorintro) && empty($moneybank) && !haspriv(9) && !haspriv(1) && !haspriv(2)) back('对不起您没有作家权限');


//提交
if($moneybank) {
	//续费申请
	if (intval($moneybank)<10 || ($Global['F_groupid']==2 && $moneybank<$Global['PricOfBecomeVIP'])) back('金额输入错误');
	$sql="insert into ".__TAB_APPLYFEE__." set user_name='".$Global['F_username']."',applyfee_time='".$Global['F_time']."',applyfee_money='$moneybank',applyfee_kind=1,applyfee_ps='$ps'";
	$db->query($sql);
	jumpage("apply.php?action=pay","续费申请成功");
}elseif($fee) {
	//兑换申请
	if (intval($fee)<$Global['AllowExMinscoin']) back('金额输入错误');
	$sql="select user_bank from ".__TAB_USER__." where ".$Global['mysql_userow']."='".$Global['F_username']."'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	if($rows['user_bank']<$fee*$Global['SiteCoinPerYuan']) back('账上余额不足');
	$sql="insert into ".__TAB_APPLYFEE__." set user_name='".$Global['F_username']."',applyfee_time='".$Global['F_time']."',applyfee_money='$fee'";
	$db->query($sql);
	jumpage("apply.php?action=fee","兑换申请成功");
}elseif($authorintro) {
	//作家申请
	$sql="insert into ".__TAB_APPLYWRITER__." set user_name='".$Global['F_username']."',applywriter_ps='$authorintro',applywriter_time='".$Global['F_time']."'";
	$db->query($sql);
	jumpage("apply.php?action=newauthor","作家申请成功");
}elseif($bookname) {
	//新书申请
	if(empty($bookname) || empty($booktype) || empty($bookintro)) back('填写不全');
	$sql="insert into ".__TAB_APPLYBOOK__." set user_name='".$Global['F_username']."',applybook_title='$bookname',applybook_author='$bookauthor',type_id='$booktype',applybook_actor='$bookactor',applybook_intro='$bookintro',applybook_attrib='$bookattrib',applybook_time='".$Global['F_time']."'";
	$db->query($sql);
	jumpage("apply.php?action=newbook","新书申请成功");
}


//显示申请表

//设定搜索关键词
$seokeyword[]='申请程序';
getheader($seokeyword);//输出头部

$tpl = new Template('apply');
$tpl->assign($Global['main_assign']);
$tpl->assign(array(
	'action' => $action,
));

$objPage = new Page;
//查询列表数目(对newauthor无效)
$sql="select user_name from ".(($action=='fee' || $action=='pay')? __TAB_APPLYFEE__:__TAB_APPLYBOOK__)." where user_name='".$Global['F_username']."' and applyfee_kind=".($action=='fee'?0:1);
$result=$db->query($sql);
$booknum=$db->num_rows($result);
$objPage->setVar(array("action"=>$action));
$objPage->setPage($Global['tiplist'],$booknum,0);
$pagelink=$objPage->output(1);
$limit=$objPage->limit();
//下面开始显示列表内容
if($action=="fee" || $action=="pay") {//金钱相关申请部分
	$sql="select applyfee_time,applyfee_checktime,applyfee_money,applyfee_ps from ".__TAB_APPLYFEE__." where applyfee_kind=".($action=='fee'?0:1)." and  user_name='".$Global['F_username']."' order by applyfee_time desc limit ".$limit;
	$result=$db->query($sql);
	while($rows=$db->fetch_row($result)){
		$Feelistblock[]=array(
			'G_style' => $Global['style'],
			'C_money' => $rows['applyfee_money']*$Global['SiteCoinPerYuan'],
			'G_MoneyTitle' => $Global['moneytitle'],
			'C_moneyfee' => $rows['applyfee_money'],
			'C_ps' => $rows['applyfee_ps'],
			'C_applytime' => gmdate("n-j",$rows['applyfee_time']),
			'C_checktime' => ($rows['applyfee_checktime']==0?'暂未审核': ($rows['applyfee_checktime']==1?'未通过' :gmdate("n-j",$rows['applyfee_checktime'])))
		);
	}
	$db->free_result($result);//释放mysql
	$sql="select user_bank from ".__TAB_USER__." where ".$Global['mysql_userow']."='".$Global['F_username']."'";
	$result=$db->query($sql);
	$rows=$db->fetch_row($result);
	$tpl->assign(array(
		'G_MoneyTitle' => $Global['moneytitle'],
		'Feelistblock' => $Feelistblock,
		'C_money' => $rows['user_bank'],
		'C_moneyfee' => number_format($rows['user_bank']/$Global['SiteCoinPerYuan'],2),
		'C_feeps' => printcodes($SiteInfo['feeps'])
	));

}elseif($action=="newauthor") {//作家申请部分
	$sql="select applywriter_time,applywriter_checktime from ".__TAB_APPLYWRITER__." where user_name='".$Global['F_username']."' order by applywriter_time desc";
	$result=$db->query($sql);
	while($rows=$db->fetch_row($result)){
		$Newauthorlistblock[]=array(
			'G_style' => $Global['style'],
			'C_applytime' => gmdate("n-j",$rows['applywriter_time']),
			'C_checktime' => ($rows['applywriter_checktime']==0?'暂未审核': ($rows['applywriter_checktime']==1?'未通过' :gmdate("n-j",$rows['applywriter_checktime'])))
		);
	}
	$db->free_result($result);//释放mysql
	$tpl->assign(array(
		'Newauthorlistblock' => $Newauthorlistblock,
		'C_username' => $Global['F_username'],
		'C_newauthorps' => printcodes($SiteInfo['newauthorps'])
	));
	unset($Newauthorlistblock);
	
}else {//新书申请列表
	$sql="select applybook_title,applybook_author,type_id,applybook_attrib,applybook_time,applybook_checktime from ".__TAB_APPLYBOOK__." ab where user_name='".$Global['F_username']."' order by applybook_time desc limit ".$limit;
	$result=$db->query($sql);
	while($rows=$db->fetch_row($result)){
		$Newbooklistblock[]=array(
			'G_style' => $Global['style'],
			'C_booktitle' => $rows['applybook_title'],
			'C_author' => $rows['applybook_author'],
			'C_typename' => $_RCACHE['booktypebytid'][$rows['type_id']],
			'C_attrib' => $rows['applybook_attrib'],
			'C_applytime' => gmdate("n-j",$rows['applybook_time']),
			'C_checktime' => ($rows['applybook_checktime']==0?'暂未审核': ($rows['applybook_checktime']==1?'未通过' :gmdate("n-j",$rows['applybook_checktime'])))
		);
	}
	$db->free_result($result);//释放mysql
	$tpl->assign(array(
		'Newbooklistblock' => $Newbooklistblock,
		'C_username' => $Global['F_username'],
		'Booktypeblock' => $_RCACHE['booktype'],
		'C_newbookps' => printcodes($SiteInfo['newbookps'])
	));
	unset($Newbooklistblock);
}

$tpl->assign('C_pagelink',$pagelink);

$tpl->output();


include_once AROOT."include/footer.inc.php";
?>