<?php
/*
	[Read8] bookarray.php

	Version: 3.1
	Name:书籍排行榜程序
	Web: http://www.read8.net
	Copyright: 2001-2006 Read8 Technology Ltd.
	Last Modified: 2006-1-16 12:02
*/
include_once "./include/init.php";

if(!$class) $class='book_click'; 

//查询列表数目
include_once AROOT.'data/cache/cache_bookmain.php';
if(is_int($class)) {
	$booknum=$_RCACHE['bookmain']['bookfreenum_'.$class];
}else {
	$booknum=$_RCACHE['bookmain']['bookfreenum'];
}
$objPage = new Page;
$objPage->setVar(array("class"=>$class));
$objPage->setPage($Global['tiplist'],$booknum,0);
$pagelink=$objPage->output(1);
$limit=$objPage->limit();
//下面开始显示列表内容

$tpl = new Template('bookarray');
$tpl->assign($Global['main_assign']);

switch($class) {
	case 'book_click': $sqladd=' order by bookhits_click desc ';$showwhat='总排行';break;
	case 'book_thisweekclick': $sqladd=' order by bookhits_lastweekclick desc ';$showwhat='本周排行';break;
	case 'book_thismonthclick': $sqladd=' order by bookhits_lastmonthclick desc ';$showwhat='本月排行';break;
	case 'book_updatetime': $sqladd=' order by b.book_updatetime desc ';$showwhat='最后更新';break;
	case 'book_recommend': $sqladd=' where b.book_recommend=1 order by b.book_updatetime desc ';$showwhat='最新推荐';break;
	case 'book_newclick': $sqladd=' where book_time>='.($Global['F_time']-$Global['newbookoverload']*86400).' order by bookhits_click desc ';$showwhat='新书点击榜';break;
	case 'book_time': $sqladd=' order by b.book_time desc ';$showwhat='最新入库';break;
	case 'book_vote': $sqladd=' order by bookhits_vote desc ';$showwhat='网友投票排行';break;
	default : $sqladd=' where b.type_id='.intval($class).' order by b.book_id desc ';$showwhat='分类列表';
}

//设定搜索关键词
$seokeyword[]=$showwhat;
$seokeyword[]='排行榜';
getheader($seokeyword);//输出头部


$sql="select b.book_id,book_title,book_updatetime,b.type_id,type_id,chapter_title,book_author,book_state, chapter_orderid,bookhits_click,bookhits_lastweekclick,bookhits_vote,volume_name 
from ".__TAB_BOOK__." b 
LEFT JOIN ".__TAB_BOOKHITS__." bh ON b.book_id=bh.book_id 
LEFT JOIN ".__TAB_CHAPTER__." c ON b.book_newchapterid=c.chapter_id 
LEFT JOIN ".__TAB_VOLUME__." vl ON vl.volume_id=c.volume_id 
".$sqladd." limit ".$limit;
$result=$db->query($sql);
while($rows=$db->fetch_row($result)){
	$Booklistblock[]=array(
		'G_style' => $Global['style'],
		'C_bookid' => $rows['book_id'],
		'C_booktitle' => $rows['book_title'],
		'C_updatetime' => gmdate("n-j",$rows['book_updatetime']),
		'C_volumetitle' => $rows['volume_name'],
		'C_typeid' => $rows['type_id'],
		'C_booktype' => $_RCACHE['booktypebytid'][$rows['type_id']],
		'C_orderid' => $rows['chapter_orderid'],
		'C_chaptertitle' => $rows['chapter_title'],
		'C_author' => $rows['book_author'],
		'C_click' => $rows['bookhits_click'],
		'C_thisweekclick' => $rows['bookhits_lastweekclick'],
		'C_vote' => $rows['bookhits_vote'],
		'C_state' => ($rows['book_state']==1 ? '连载中' : ($rows['book_state']==2 ? '暂停中' : '全书完'))
	);
}
$db->free_result($result);//释放mysql
$tpl->assign(array(
	'G_style' => $Global['style'],
	'Booklistblock' => $Booklistblock,
	'C_orderby' => $showwhat,
	'C_pagelink' => $pagelink
));
unset($Booklistblock);


$tpl->output();


include_once AROOT."include/footer.inc.php";
?>