-- phpMyAdmin SQL Dump
-- version 2.7.0-rc1
-- http://www.phpmyadmin.net
-- 
-- 主机: localhost
-- 生成日期: 2006 年 08 月 18 日 07:10
-- 服务器版本: 5.0.22
-- PHP 版本: 5.1.4
-- 
-- 数据库: `read8`
-- 

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_actlog
-- 

DROP TABLE IF EXISTS rd8_read8_actlog;
CREATE TABLE rd8_read8_actlog (
  `actlog_id` int(10) NOT NULL auto_increment,
  `user_name` varchar(20) NOT NULL default '',
  `actlog_act` varchar(100) NOT NULL default '',
  `actlog_time` int(10) NOT NULL default '0',
  `actlog_ip` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`actlog_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='操作记录表结构' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_announce
-- 

DROP TABLE IF EXISTS rd8_read8_announce;
CREATE TABLE rd8_read8_announce (
  `announce_id` smallint(5) NOT NULL auto_increment,
  `announce_content` text NOT NULL,
  `announce_time` int(10) NOT NULL default '0',
  PRIMARY KEY  (`announce_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='网站公告表结构' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_applybook
-- 

DROP TABLE IF EXISTS rd8_read8_applybook;
CREATE TABLE rd8_read8_applybook (
  `applybook_id` int(10) NOT NULL auto_increment,
  `applybook_title` varchar(50) NOT NULL default '',
  `applybook_author` varchar(50) NOT NULL default '',
  `type_id` smallint(2) NOT NULL default '1',
  `applybook_actor` varchar(100) NOT NULL default '',
  `applybook_intro` text NOT NULL,
  `applybook_attrib` varchar(10) NOT NULL default '',
  `user_name` varchar(20) NOT NULL default '',
  `applybook_time` int(10) NOT NULL default '0',
  `applybook_checktime` int(10) NOT NULL default '0',
  PRIMARY KEY  (`applybook_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='新书申请列表结构' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_applyfee
-- 

DROP TABLE IF EXISTS rd8_read8_applyfee;
CREATE TABLE rd8_read8_applyfee (
  `applyfee_id` int(10) NOT NULL auto_increment,
  `user_name` varchar(20) NOT NULL default '',
  `applyfee_time` int(10) NOT NULL default '0',
  `applyfee_checktime` int(10) NOT NULL default '0',
  `applyfee_money` int(10) NOT NULL default '0',
  `applyfee_kind` tinyint(1) NOT NULL default '0',
  `applyfee_ps` text NOT NULL,
  PRIMARY KEY  (`applyfee_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='兑换和续费申请表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_applywriter
-- 

DROP TABLE IF EXISTS rd8_read8_applywriter;
CREATE TABLE rd8_read8_applywriter (
  `applywriter_id` int(10) NOT NULL auto_increment,
  `user_name` varchar(20) NOT NULL default '',
  `applywriter_time` int(10) NOT NULL default '0',
  `applywriter_checktime` int(10) NOT NULL default '0',
  `applywriter_checkkind` varchar(10) NOT NULL default '',
  `applywriter_ps` text NOT NULL,
  PRIMARY KEY  (`applywriter_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='作家申请表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_attach
-- 

DROP TABLE IF EXISTS rd8_read8_attach;
CREATE TABLE rd8_read8_attach (
  `attach_id` int(6) NOT NULL auto_increment,
  `book_id` int(10) NOT NULL default '0',
  `chapter_id` int(10) NOT NULL default '0',
  `attach_date` int(10) NOT NULL default '0',
  `attach_filename` varchar(50) NOT NULL default '',
  `attach_filekind` varchar(9) NOT NULL default '',
  `attach_filesize` int(20) NOT NULL default '0',
  `attach_hits` int(9) NOT NULL default '0',
  PRIMARY KEY  (`attach_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_autobank
-- 

DROP TABLE IF EXISTS rd8_read8_autobank;
CREATE TABLE rd8_read8_autobank (
  `autobank_id` int(10) NOT NULL auto_increment,
  `user_name` varchar(20) NOT NULL default '',
  `autobank_time` int(10) NOT NULL default '0',
  `autobank_money` int(10) NOT NULL default '0',
  `autobank_check` tinyint(1) NOT NULL default '0',
  `autobank_checkbank` varchar(10) NOT NULL default 'alipay',
  PRIMARY KEY  (`autobank_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='在线支付记录和订单表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_banlist
-- 

DROP TABLE IF EXISTS rd8_read8_banlist;
CREATE TABLE rd8_read8_banlist (
  `ban_id` mediumint(8) NOT NULL auto_increment,
  `ban_name` varchar(12) NOT NULL default '',
  `ban_username` varchar(12) NOT NULL default '',
  `ban_word` varchar(12) NOT NULL default '',
  `ban_ip` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`ban_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='封禁列表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_book
-- 

DROP TABLE IF EXISTS rd8_read8_book;
CREATE TABLE rd8_read8_book (
  `book_id` int(10) NOT NULL auto_increment,
  `book_title` varchar(200) NOT NULL default '',
  `user_name` varchar(20) NOT NULL default '',
  `book_author` varchar(20) NOT NULL default '',
  `type_id` smallint(2) NOT NULL default '0',
  `book_actor` varchar(100) NOT NULL default '',
  `book_intro` text NOT NULL,
  `book_attrib` varchar(10) NOT NULL default '',
  `book_initial` char(2) NOT NULL default '',
  `book_time` int(10) NOT NULL default '0',
  `book_updatetime` int(10) NOT NULL default '0',
  `book_newchapterid` int(10) NOT NULL default '0',
  `book_size` int(10) NOT NULL default '0',
  `book_state` smallint(1) NOT NULL default '1',
  `book_recommend` smallint(1) NOT NULL default '0',
  `book_md5` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`book_id`),
  KEY `bookindex` (`book_time`,`book_updatetime`,`book_state`,`book_attrib`,`book_newchapterid`,`book_initial`,`type_id`,`book_md5`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='书籍表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_bookcase
-- 

DROP TABLE IF EXISTS rd8_read8_bookcase;
CREATE TABLE rd8_read8_bookcase (
  `bookcase_id` int(10) NOT NULL auto_increment,
  `user_name` varchar(20) NOT NULL default '',
  `type_name` varchar(20) NOT NULL default '',
  `chapter_orderid` varchar(100) NOT NULL default '0',
  `book_id` int(10) NOT NULL default '0',
  PRIMARY KEY  (`bookcase_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='个人书架表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_bookface
-- 

DROP TABLE IF EXISTS rd8_read8_bookface;
CREATE TABLE rd8_read8_bookface (
  `bookface_id` int(10) NOT NULL auto_increment,
  `book_id` int(10) NOT NULL default '0',
  `type_id` smallint(2) NOT NULL default '0',
  `book_title` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`bookface_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='书籍封面推荐表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_bookhits
-- 

DROP TABLE IF EXISTS rd8_read8_bookhits;
CREATE TABLE rd8_read8_bookhits (
  `bookhits_id` int(10) NOT NULL auto_increment,
  `book_id` int(10) NOT NULL default '0',
  `bookhits_click` int(10) NOT NULL default '0',
  `bookhits_lastweekclick` int(10) NOT NULL default '0',
  `bookhits_lastweektotleclick` int(10) NOT NULL default '0',
  `bookhits_lastmonthclick` int(10) NOT NULL default '0',
  `bookhits_lastmonthtotleclick` int(10) NOT NULL default '0',
  `bookhits_vote` int(10) NOT NULL default '0',
  PRIMARY KEY  (`bookhits_id`),
  KEY `bookhitsindex` (`book_id`,`bookhits_click`,`bookhits_lastweekclick`,`bookhits_vote`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='书籍点击量表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_bookreview
-- 

DROP TABLE IF EXISTS rd8_read8_bookreview;
CREATE TABLE rd8_read8_bookreview (
  `bookreview_id` int(10) NOT NULL auto_increment,
  `book_id` int(10) NOT NULL default '0',
  `user_name` varchar(20) NOT NULL default '',
  `bookreview_content` text NOT NULL,
  `bookreview_time` int(10) NOT NULL default '0',
  PRIMARY KEY  (`bookreview_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='书评表结构' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_booktype
-- 

DROP TABLE IF EXISTS rd8_read8_booktype;
CREATE TABLE rd8_read8_booktype (
  `type_id` smallint(2) NOT NULL auto_increment,
  `type_name` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`type_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='书籍类型表结构' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_buylist
-- 

DROP TABLE IF EXISTS rd8_read8_buylist;
CREATE TABLE rd8_read8_buylist (
  `buylist_id` int(10) NOT NULL auto_increment,
  `user_name` varchar(20) NOT NULL default '',
  `chapter_id` int(10) NOT NULL default '0',
  `buylist_time` int(10) NOT NULL default '0',
  PRIMARY KEY  (`buylist_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='章节购买记录表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_chapter
-- 

DROP TABLE IF EXISTS rd8_read8_chapter;
CREATE TABLE rd8_read8_chapter (
  `chapter_id` int(10) NOT NULL auto_increment,
  `chapter_title` varchar(200) NOT NULL default '',
  `book_id` int(10) NOT NULL default '0',
  `chapter_orderid` int(10) NOT NULL default '0',
  `chapter_time` int(10) NOT NULL default '0',
  `chapter_updatetime` int(10) NOT NULL default '0',
  `chapter_new` tinyint(1) NOT NULL default '0',
  `chapter_words` int(10) NOT NULL default '0',
  `chapter_tmpurl` varchar(32) NOT NULL default '',
  `chapter_preview` text,
  `volume_id` int(10) NOT NULL default '0',
  `chapter_md5` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`chapter_id`),
  KEY `chapter_orderid` (`chapter_orderid`,`chapter_time`,`chapter_new`,`book_id`,`volume_id`,`chapter_md5`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='章节表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_group
-- 

DROP TABLE IF EXISTS rd8_read8_group;
CREATE TABLE rd8_read8_group (
  `group_id` mediumint(8) NOT NULL auto_increment,
  `group_name` varchar(40) NOT NULL,
  `group_priv` int(10) NOT NULL default '0',
  `group_description` varchar(255) NOT NULL,
  `group_moderator` varchar(12) NOT NULL default '',
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='群组表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_priv
-- 

DROP TABLE IF EXISTS rd8_read8_priv;
CREATE TABLE rd8_read8_priv (
  `priv_id` int(8) NOT NULL auto_increment,
  `priv_name` varchar(40) NOT NULL,
  PRIMARY KEY  (`priv_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='书网权限列表' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_sessions
-- 

DROP TABLE IF EXISTS rd8_read8_sessions;
CREATE TABLE rd8_read8_sessions (
  `sessions_sid` char(32) character set utf8 collate utf8_bin NOT NULL default '',
  `sessions_ip1` tinyint(3) unsigned NOT NULL default '0',
  `sessions_ip2` tinyint(3) unsigned NOT NULL default '0',
  `sessions_ip3` tinyint(3) unsigned NOT NULL default '0',
  `sessions_ip4` tinyint(3) unsigned NOT NULL default '0',
  `sessions_uid` mediumint(8) unsigned NOT NULL default '0',
  `sessions_username` char(15) NOT NULL default '',
  `sessions_groupid` smallint(6) unsigned NOT NULL default '0',
  `sessions_hidden` tinyint(1) NOT NULL default '0',
  `sessions_email` varchar(40) NOT NULL default '',
  `sessions_empiretime` int(10) NOT NULL default '0',
  `sessions_priv` int(10) NOT NULL default '0',
  UNIQUE KEY `sessions_sid` (`sessions_sid`),
  KEY `sessions_uid` (`sessions_uid`,`sessions_username`)
) ENGINE=HEAP DEFAULT CHARSET=utf8 COMMENT='在线列表';

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_sitelink
-- 

DROP TABLE IF EXISTS rd8_read8_sitelink;
CREATE TABLE rd8_read8_sitelink (
  `sitelink_id` smallint(5) NOT NULL auto_increment,
  `sitelink_name` varchar(50) default NULL,
  `sitelink_url` varchar(250) default NULL,
  `sitelink_logo` varchar(250) default NULL,
  PRIMARY KEY  (`sitelink_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='书网友情链接' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_user
-- 

DROP TABLE IF EXISTS rd8_read8_user;
CREATE TABLE rd8_read8_user (
  `user_id` mediumint(8) NOT NULL auto_increment,
  `user_name` varchar(12) NOT NULL default '',
  `user_pwd` varchar(32) NOT NULL default '',
  `user_icon` varchar(120) NOT NULL default '',
  `user_email` varchar(40) NOT NULL default '',
  `user_qq` int(9) NOT NULL default '0',
  `user_regdate` int(10) NOT NULL default '0',
  `user_comm` text,
  `user_publicemail` tinyint(1) NOT NULL default '0',
  `user_sex` varchar(4) NOT NULL default '',
  `user_born` date NOT NULL default '0000-00-00',
  `user_money` int(10) NOT NULL default '0',
  `user_bank` int(10) NOT NULL default '0',
  `group_id` smallint(5) NOT NULL default '2',
  `user_privinfo` text,
  PRIMARY KEY  (`user_id`),
  UNIQUE KEY `user_name` (`user_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='用户表结构' AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

-- 
-- 表的结构 rd8_read8_volume
-- 

DROP TABLE IF EXISTS rd8_read8_volume;
CREATE TABLE rd8_read8_volume (
  `volume_id` int(10) NOT NULL auto_increment,
  `book_id` int(10) NOT NULL default '0',
  `volume_name` varchar(100) NOT NULL default '',
  `volume_chapterorderid` int(10) NOT NULL default '0',
  PRIMARY KEY  (`volume_id`),
  KEY `book_id` (`book_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='章节表' AUTO_INCREMENT=1 ;
